unit mdb;

interface

function    CreateDatabase(const Path: string; var Err: string): Boolean;
function    ChangePassword(const Path, OldPath, NewPass: string; var Err: string): Boolean;
function    CompactDatabase(const Path, Pass: string; var Err: string): Boolean;

type
    TPoorMdb = class
    private
        OLE_DB      : OleVariant;
        FPath       : string;                
        FPass       : string;
        FConnStr    : string;
    public
        constructor Create(const Path, Pass: string);
        destructor  Destroy(); override;
        function    Open(var Err: string): Boolean;
        procedure   Close();
        function    Execute(const SQL: string; var Err: string): Boolean;
        procedure   BeginTrans();
        procedure   Commit();
        procedure   Rollback();
    end;

implementation

uses
    Windows, SysUtils, ComObj, ActiveX, Variants;

//  ---------------------------------------------------------------------------
//  f[^x[X쐬
function    CreateDatabase(const Path: string; var Err: string): Boolean;
const
    CONN_STR = 'Provider=Microsoft.Jet.OLEDB.4.0;Data Source="%s"';
var
    Catalog: OleVariant;
    ConnStr: string;
begin
    Result := false;
    ConnStr := Format(CONN_STR, [Path]);
    try
        try
            Catalog := CreateOleObject('ADOX.Catalog');
            Catalog.Create(ConnStr);
        finally
            Catalog := Unassigned;
        end;
        Result := true;
    except
        on E:Exception do Err := E.Message;
    end;
end;

//  ---------------------------------------------------------------------------
//  pX[hݒEύX
function    ChangePassword(const Path, OldPath, NewPass: string; var Err: string): Boolean;
const
    CONN_STR = 'Data Source="%s";Jet OLEDB:Database Password=%s';
var
    Engine: OleVariant;
    Temp: string;
    S1, S2: string;
begin
    Result := false;
    //  kw
    Temp := ChangeFileExt(Path, '.bak');
    //  Ώ(Ă悢Ȃ)
    DeleteFile(Temp);
    //  ڑ񕗍쐬
    S1 := Format(CONN_STR, [Path, OldPath]);
    S2 := Format(CONN_STR, [Temp, NewPass]);
    try
        try
            //  
            Engine := CreateOleObject('JRO.JetEngine');
            Engine.CompactDatabase(S1, S2);
            //  u
            DeleteFile(Path);
            RenameFile(Temp, Path);
        finally
            Engine := Unassigned;
        end;
        Result := true;
    except
        on E:Exception do Err := E.Message;
    end;
end;

//  ---------------------------------------------------------------------------
//  œK
function    CompactDatabase(const Path, Pass: string; var Err: string): Boolean;
begin
    Result := ChangePassword(Path, Pass, Pass, Err);
end;

//  ---------------------------------------------------------------------------
//  RXgN^
constructor TPoorMdb.Create(const Path, Pass: string);
const
    CONN_STR = 'Provider=Microsoft.Jet.OLEDB.4.0;'
             + 'Jet OLEDB:Database Password="%s";Data Source="%s"';
begin
    //  
    OLE_DB := Unassigned;
    //  Ă
    FPath := Path;
    FPass := Pass;
    //  閧̎쐬
    FConnStr := Format(CONN_STR, [FPass, FPath]);
end;
//  ---------------------------------------------------------------------------
//  fXgN^
destructor  TPoorMdb.Destroy();
begin
    //  ÔߕĂ
    Close();
end;
//  ---------------------------------------------------------------------------
//  J
function    TPoorMdb.Open(var Err: string): Boolean;
begin
    Result := false;
    try
        //  ڑ(?)
        OLE_DB := CreateOleObject('ADODB.Connection');
        //  J(.ldb쐬)
        OLE_DB.Open(FConnStr);
        Result := true;
    except
        on E:Exception do
        begin
            Err := E.Message;
            //  
            OLE_DB := Unassigned;
        end;
    end;
end;
//  ---------------------------------------------------------------------------
//  
procedure   TPoorMdb.Close();
begin
    //  ڑĂȂ
    if not VarIsEmpty(OLE_DB) then
    begin
        //  ď
        OLE_DB.Close;
        OLE_DB := Unassigned;
    end;
end;
//  ---------------------------------------------------------------------------
//  NG[s
function    TPoorMdb.Execute(const SQL: string; var Err: string): Boolean;
begin
    Result := false;
    try
        OLE_DB.Execute(SQL);
        Result := true;
    except
        on E:Exception do Err := E.Message;
    end;
end;
//  ---------------------------------------------------------------------------
//  gUNVJn
procedure   TPoorMdb.BeginTrans();
begin
    OLE_DB.BeginTrans;
end;
//  ---------------------------------------------------------------------------
//  R~bg
procedure   TPoorMdb.Commit();
begin
    OLE_DB.CommitTrans;
end;
//  ---------------------------------------------------------------------------
//  [obN
procedure   TPoorMdb.Rollback();
begin
    OLE_DB.RollbackTrans;
end;

end.

